--- Server Heartbeat - writes Timestamps
-- Can be checked by an external watchdog program

HEARTBEAT_INTERVAL = 1*60  	-- Heartbeat "pulse" length in seconds
FILE = "Heartbeat.txt"		-- FILE to check (root path is server root)
TIMER = "Heartbeat"			-- Timer name

--- kill old timer if any:
if this:HasTimer(TIMER) then 	this:RemoveTimer(TIMER) end


function HandleHeartbeat()
	local file = io.open (FILE ,"w+")
   	file:write(tostring(DateTime.Now:ToString() ) )
	file:close()
	this:ScheduleTimerDelay(TimeSpan.FromSeconds(HEARTBEAT_INTERVAL),TIMER,{})
	end

RegisterEventHandler(EventType.Timer,TIMER, HandleHeartbeat)

-- start the heartbeat sequence
this:FireTimer(TIMER)