require 'incl_equipmentstats'
require 'incl_recipes'
require 'incl_crafting'

CustomItemValues = {
	-- faction shields are given away for free and have no value
	shield_large_fire = 0,
	shield_large_water = 0,
	shield_large_earth = 0,

	-- until tools are craftable we hardcode their values
	tool_hammer = 9,
	tool_hatchet = 12,
	tool_mining_pick = 9,
	tool_shovel = 17,
	tool_cookingpot = 23,
	tool_hunting_knife = 10,

	--Resources
	resource_stone = 0.3,
	resource_wood = 0.6,
	resource_boards = 3,
	resource_sand = 0.20,
	resource_clothscraps = 1,
	resource_bolt_of_fabric = 10,
	--Aldor: added copper, tin, bronze, coal, steel
	resource_copper_ore = 2,
	resource_copper_ingots = 20,
	resource_copperscraps = 0.4,
	resource_tin_ore = 4,
	resource_bronze_ingots = 30,
	resource_bronzescraps = 0.6,
	resource_iron_ore = 8,
	resource_iron_ingots = 80,
	resource_ironscraps = 1.8,
	resource_coal = 0.5,
	resource_steel_ingots = 120,
	resource_steelscraps = 2,
	resource_cobalt_ore = 40,
	resource_cobalt_ingots = 400,
	resource_cobaltscraps = 6,
	--Aldor: end of modification
	resource_leatherscraps = 1.25,
	resource_brute_leatherscraps = 5,
	resource_leather_tanned = 11.76,
	resource_gilded_leather = 100,
	resource_silk_fabric = 40,
	resource_silkscraps = 2,
	resource_cotton = 2,
	resource_blightwood = 1.67,
	resource_blightwood_boards = 33,
	resource_essence = 1,
	gold_ingot = 500,

	--Animal Parts
	animalparts_spider_silk = 2,
	animalparts_wolf_fang = 8,
	animalparts_dire_wolf_fang = 711,
	animalparts_snake_skin = 4,
	animalparts_viper_skin = 17,
	animalparts_bear_claw = 13,
	animalparts_ancient_bear_claw = 691,
	animalparts_ancient_bear_fang = 650,
	animalparts_turkey_feathers = 12,
	animalparts_spider_eye = 3,
	animalparts_purple_spider_eye = 690,
	--animalparts_rabbit_foot = 3,
	animalparts_rat_ear = 14,
	animalparts_plague_rat_ear = 568,
	animalparts_ogre_tooth = 609,
	animalparts_bat_ear = 4,
	animalparts_beetle_extract = 27,
	--animalparts_demon_blood = 3,
	animalparts_gloss_silk = 609,
	animalparts_werebat_blood = 21,
	animalparts_worm_extract = 4,
	animalparts_beetle_extract = 5,
	animalparts_meat = 2,
	animalparts_cooked_meat = 5,
	animalparts_leather_hide = 4,
	animalparts_human_skull = 7.5,
	animalparts_brute_leather_hide = 16,
	--ingredient_mummified_skull = 54,

	--Harvest Resources
	ingredient_lemongrass = 0.25,
	ingredient_lemongrass_shoot = 1.58,
	ingredient_ginsengroot = 0.6,
	ingredient_ancient_gingsengroot = 4.3,
	ingredient_mushroom = 0.5,
	ingredient_mushroom_fragrant = 5,
	ingredient_moss = 3,
	ingredient_moss_herbal = 21,
	ingredient_olive_oil = 1.8,
	ingredient_olive_oil_pure = 18,
	ingredient_cactus = 2.5,
	ingredient_sacred_cactus = 42,
	ingredient_wine = 1,
	ingredient_wine_aged = 9,

	--Skill Books
	skill_animalken = 25,
	skill_bashing = 25,
	skill_blocking = 25,
	skill_butchery = 25,
	skill_channeling = 25,
	skill_cooking = 25,
	skill_dodge = 25,
	skill_endurance = 25,
	skill_fabrication = 25,
	skill_foraging = 25,
	skill_lumberjack = 25,
	skill_magica_ffinity = 25,
	skill_metalsmith = 25,
	skill_mining = 25,
	skill_piercing = 25,
	skill_regeneration = 25,
	skill_rogue = 25,
	skill_slavage = 25,
	skill_slashing = 25,

	--Scrolls
	scroll_cloak = 250,
	scroll_cloak_enhanced = 600,
	scroll_decipher = 20,
	scroll_fireball = 30,
	scroll_fireball_enhanced = 200,
	scroll_heal = 40,
	scroll_heal_enhanced = 200,
	scroll_icelance = 250,
	scroll_icelance_enhanced = 600,
	scroll_lightning = 120,
	scroll_lightning_enhanced = 350,
	scroll_pillaroffire = 250,
	scroll_flameaura = 80,
	scroll_readable = 20,
	scroll_resurrect = 100,
	scroll_teleport = 175,
	scroll_teleport_enhanced = 400,
	scroll_bindportal = 120,
	scroll_bombardment = 500,
	scroll_spikepath = 400,
	scroll_walloffire = 400,

	--Items
	candle = 10,
	pouch = 10,
	lockbox = 30,
	celador_map_scroll = 40,
	--Aldor: potions are *3 expensive
	potion_health = 18,
	potion_mana = 18,
	potion_refresh = 30,
	potion_stamina = 18,
	potion_completeheal = 60,
	--Aldor: end of modification
	bandages = 10,
	burnt_stew = 6,
	cooked_stew =6,
	diamond_gem = 2000,
	emerald_gem = 700,
	ruby_gem = 600,
	sapphire_gem = 650,
	ingredient_broccoli = 4,
	ingredient_cabbage = 4,
	ingredient_cucumber = 4,
	ingredient_green_pepper = 4,
	ingredient_onion = 4,
	ingredient_potato = 4,
	ingredient_tomato = 4,
	inn_stew = 15,
	item_ale = 3,
	item_apple = 4,
	item_beer = 4,
	item_bread = 7,
	item_mead = 4,
	item_bowl = 3,
	meat_stew = 10,
	book_blue = 7,
	book_brown = 7,
	book_green = 7,
	book_grey = 7,
	book_red = 7,
	book_yellow = 7,
	dye_black = 25,
	dye_blue = 25,
	dye_blue_light = 25,
	dye_brown = 25,
	dye_brown_light = 25,
	dye_gold = 25,
	dye_gold_light = 25,
	dye_green = 25,
	dye_green_light = 25,
	dye_grey = 25,
	dye_grey_light = 25,
	dye_orange = 25,
	dye_orange_light = 25,
	dye_pink = 25,
	dye_pink_light = 25,
	dye_red = 25,
	dye_red_light = 25,
	dye_remover = 25,
	dye_yellow = 25,
	dye_yellow_light = 25,
	artifact_gold_bracelet = 35,
	artifact_mask = 35,
	artifact_ornate_goblet = 35,
	artifact_pendant = 35,
	artifact_small_statue = 35,
	key = 8,

	blueprint_stonehouseblacksmith = 2000,
	blueprint_stonehousecottage = 5000,
	blueprint_stonehouseestate = 15000,
	blueprint_stonehousetuscan = 2500,
	blueprint_stonehousevilla = 6000,
	blueprint_tudorhouse = 1500,
	blueprint_tudorhousebirch = 4500,
	blueprint_tudorhouseestate = 15000,
	blueprint_tudorhousemahogany = 475,
	blueprint_tudorhousemanor = 14000,
	blueprint_tudorhouseoak = 4000,
	blueprint_woodhouse = 180,
	blueprint_woodhousecottage = 250,

	recipe_bedsmall = 15,
	recipe_woodentablelarge = 40,
	recipe_fancychair = 80,
	recipe_woodentable = 35,
	recipe_woodenchair = 10,
	recipe_stool = 15,
	recipe_fancybench = 80,
	recipe_woodendesk = 50,
	recipe_woodendesk = 50,
	recipe_alchemytable = 150,
	recipe_loom = 150,
	recipe_forge = 150,
	recipe_woodsmithtable = 150,
	recipe_maul = 60,
	recipe_miningpick = 40,
	recipe_glaive = 60,
	recipe_battleaxe = 60,
	recipe_dagger = 60,
	recipe_greathammer = 60,
	recipe_longsword = 60,
	recipe_rapier = 60,
	recipe_spear = 60,
	recipe_hatchet = 40,
	recipe_hunting_knife = 25,

	holy_water = 0,
}

ItemPropertyValues = {

	BonusMinDamage = { 
		value =  15, 
		gradient = 1, 
	},
	
	BonusMaxDamage = { 
		value =  10, 
		gradient = 1, 
	},

	BonusSpeedOffset = { 
		value =  30, 
		gradient = -.1, 
	},

	BonusFinalDamage = { 
		value =  10, 
		gradient = 1, 
	},

	BonusParryChance = { 
		value =  10, 
		gradient = 1, 
	},

	BonusCritChance = { 
		value =  15, 
		gradient = 1, 
	},

	BonusRangeOffset = { 
		value =  20, 
		gradient = .1, 
	},

	BonusPenetration = { 
		value =  30, 
		gradient = 1, 
	},

	BonusDurability = { 
		value =  10, 
		gradient = 1, 
	},

	BonusMinBlockChance = { 
		value =  5, 
		gradient = 1, 
	},

	BonusIncreasedBlockChance = { 
		value =  8, 
		gradient = 1, 
	},

	BonusAbsorption = { 
		value =  5, 
		gradient = 1, 
	},

	BonusBlockCooldown = { 
		value =  20, 
		gradient = -.1, 
	},

	BonusBlockDuration = { 
		value =  20, 
		gradient = .1, 
	},

	BonusSwingSpeedModifier = { 
		value =  25, 
		gradient = -1, 
	},

	BonusEvasionModifier = { 
		value =  20, 
		gradient = 1, 
	},

	BonusPiercingResist = { 
		value =  25, 
		gradient = 1, 
	},

	BonusSlashingResist = { 
		value =  25, 
		gradient = 1, 
	},

	BonusBashingResist = { 
		value =  30, 
		gradient = 1, 
	},

	BonusManaBarrier = { 
		value =  15, 
		gradient = 1, 
	},

	BonusStaminaModifier = { 
		value =  20, 
		gradient = 1, 
	},

	BonusHarvestDelay = { 
		value =  10, 
		gradient = -.1, 
	},

	BonusHarvestEfficiency = { 
		value =  20, 
		gradient = 5, 
	},

	BonusHarvestYield = { 
		value =  30, 
		gradient = .05, 
	},

	SpellConduit = { 
		value =  40, 
		gradient = 1, 
	},

}

function GetNumBonuses(item)
	local objVarDict = item:GetAllObjVars()

	local bonusCount = 0
	for name,varValue in pairs(objVarDict) do
		if( name:match("Bonus") ) then
			bonusCount = bonusCount + 1
		end
	end

	return bonusCount
end

function GetItemBaseBonusValueMod(item)
	local baseStart = item:GetObjVar("Durability")
	if(baseStart == nil) then return 0 end

	local basePriceMod = baseStart * DURABILTY_VALUE_MULTIPLIER * (baseStart * 0.06)^2
	for i,v in pairs(ItemPropertyValues) do
		local curVal = item:GetObjVar(i)
		if(curVal ~= nil) then
			local curPot = curVal / ItemPropertyValues[i].gradient
			local modiEff = 1
			if(curPot < 0) then modiEff = .5 end
			local newVal = curPot * ItemPropertyValues[i].value * modiEff
			basePriceMod = basePriceMod + newVal
		end
	end

	-- when the mod is 0 that means the item has no bonuses
	if(basePriceMod == 0) then
		return 0
	end

	return basePriceMod /100
end


function GetBaseItemValue(item)
	-- first check for custom value by template id
	--LuaDebugCallStack("tf")
	local itemTemplateId = item:GetCreationTemplateId()
	if(itemTemplateId == nil) then
		DebugMessage("WARNING: Item has no creation template! "..tostring(item:GetName()))
		return 0
	end
	
	if (item:HasObjVar("Worthless")) then
		return 0 
	end

	if (item:HasModule("packed_object")) then
		itemTemplateId = item:GetObjVar("UnpackedTemplate")
	end

	if (item:HasObjVar("lockObject") and item:IsValid()) then
		return 0
	end
	
	if( CustomItemValues[itemTemplateId] ~= nil ) then
		return CustomItemValues[itemTemplateId]
	end

	-- most animal parts are worth 5
	if( itemTemplateId:match("animalparts") ) then
		return 3
	end

	if (item:HasObjVar("Valuable")) then
		return item:GetObjVar("Valuable")
	end

	-- some resource types have value
	local resourceType = item:GetObjVar("ResourceType")
	if( resourceType ~= nil ) then
		if( resourceType == "coins") then
			return 0
		-- refresh potions are worth more
		elseif( resourceType == "potion_refresh_regen") then
			return 5		
		elseif( resourceType:match("potion") ) then
			return 3
		elseif( resourceType:match("bandages") ) then
			return 3
		elseif( resourceType:match("Wood") ) then
			return 1
		elseif( resourceType:match("Stone") ) then
			return 1
		elseif( resourceType:match("Iron") ) then
			return 10
		end
	end

	local foodValue = item:GetObjVar("FoodValue")
	if( foodValue ~= nil ) then
		return math.max(1,math.floor(foodValue/4))
	end

	-- scrolls and skill books
	if( item:HasModule("spell_scroll") or item:HasModule("skill_book") ) then
		return 5
	end
	local itemBaseTemp = item:GetObjVar("BaseItemObjVar") or item:GetCreationTemplateId()
	if(itemBaseTemp ~= nil) then
		-- no explicit price for this base tempalte so lets
		-- extrapolate from the resource values
		local dur = item:GetObjVar("Durability")
		local maxDur = item:GetObjVar("MaxDurability")
		local durRatio = 1
		if (dur ~= nil and maxDur ~= 0 ) then
			durRatio = dur/maxDur
		end

		local sourceRecipe = GetRecipeForBaseTemplate(itemBaseTemp)
		if(sourceRecipe ~= nil) then
			local canUseResourceMethod = true
			baseRet = 0
			local quality = GetQualityString(item)
			local resourceTable = GetQualityResourceTable(sourceRecipe.Resources,quality)
			for resourceName,recipeAmount in pairs (resourceTable) do
				if(ResourceData.ResourceInfo[resourceName] ~= nil) then
					local templateName = ResourceData.ResourceInfo[resourceName].Template
					if(CustomItemValues[templateName] ~= nil) then
						baseRet = baseRet + (CustomItemValues[templateName] * recipeAmount)
					else
						-- if one or more of the resources do not have a value specified we can not use this method
						canUseResourceMethod = false
						DebugMessage("WARNING: Recipe based item contains a resource which has no CustomItemValue "..resourceType,templateName)
					end
				else
					canUseResourceMethod = false
					DebugMessage("WARNING: Recipe based item contains a resource which has no Resource entry in ResourceData.ResourceInfo table. "..resourceName)
				end
			end

			if(canUseResourceMethod) then
				--DebugMessage("Price evaluation from resources "..baseRet,itemBaseTemp,quality)
				return baseRet * durRatio
			end
		end		
	end
	local equipClass = GetEquipmentClass(item)
	if( equipClass == "WeaponClass" ) then
		local baseValue = 0
		local weaponClass = GetWeaponClass(item)
		if( weaponClass == "Vshort" ) then
			baseValue = 2
		elseif( weaponClass == "Short" or weaponClass == "ShortMid" ) then
			baseValue = 3
		elseif( weaponClass == "Mid" or weaponClass == "MidLong" ) then
			baseValue = 4
		elseif( weaponClass == "Long" ) then
			baseValue = 5
		end
		return baseValue + (GetNumBonuses(item) * 2)
	elseif( equipClass == "ArmorClass" ) then
		local baseValue = 0
		local baseMult = 1
		local armorClass = GetArmorClass(item)
		-- padded
		if( armorClass == "VeryLight") then
			baseMult = 1
		-- leather
		elseif( armorClass == "Light") then
			baseMult = 1.5
		-- chain and scale
		elseif( armorClass == "Medium" or armorClass == "Heavy") then
			baseMult = 2
		-- plate
		elseif( armorClass == "VeryHeavy") then
			baseMult = 2.5
		end

		local equipSlot = GetEquipSlot(item)
		if( equipSlot == "Head" or equipSlot == "Legs") then
			baseValue = 2 * baseMult
		elseif( equipSlot == "Chest" ) then
			baseValue = 4 * baseMult		
		end

		local combinedValue = baseValue + (GetNumBonuses(item) * 2)

		-- cultist armor is worth half
		if(itemTemplateId:match("cultist")) then
			combinedValue = combinedValue / 2
		end

		return math.floor(combinedValue)

	elseif( equipClass == "ShieldClass" ) then
		local baseValue = 0
		local shieldClass = GetShieldClass(item)
		if( shieldClass == "Buckler") then
			baseValue = 2
		elseif( shieldClass == "Small" or shieldClass == "Medium") then
			baseValue = 3
		elseif( shieldClass == "Large" or armorClass == "ExtraLarge") then
			baseValue = 5		
		end
		--DebugMessage(GetNumBonuses(item))
		--DebugMessage(tostring(baseValue + (GetNumBonuses(item) * 2)))
		return baseValue + (GetNumBonuses(item) * 2)
	end
	return 0
end

function GetItemValue(item)
	--DebugMessage("ItemValue",tostring(item),GetBaseItemValue(item),GetItemBaseBonusValueMod(item))
	return GetBaseItemValue(item) + GetItemBaseBonusValueMod(item)
end
