-- Effect presets

-- Effect presets. You can use them in templates of apply them directly.
EffectPresets = {}

-- Effects packs are packs of effect presets for easy multi-application (TODO)
EffectPacks = {}

EffectPresets.ToadstoolPoison = {
	abstractType = "naturalPoison",
	simpleDmg = 1,
	duration = 80 * 1000,

	StatModifier = {
		Identifier = "ToadstoolPoison",
		DamageMod = {Type = "Multiplier", Value = 0.3}
	},

	Announce = {
		ApplyMessage = "You should not have eaten that mushroom..."
	}
}

EffectPresets.AdminCurse = { -- FUN!
	abstractType = "misc",
	simpleDmg = 1,
	duration = 120 * 1000,

	StatModifier = {
		Identifier = "AdminCurse",
		DamageMod = {Type = "Multiplier", Value = 0.0},
		HealthRegenMod = {Type = "Multiplier", Value = 0.0},
		ManaRegenMod = {Type = "Multiplier", Value = 0.0}
	},

	Announce = {
		ApplyMessage = "It feels like something cold would have gone to your heart... You have been cursed!",
		RemoveMessage = "You feel curse finally weakening it's grip on you body..."
	}
}

function GetEffectPreset(name)
	local preset = EffectPresets[name]
	if type(preset) ~= "table" then return end
	preset.specificType = name
	return preset
end