---
require 'base_ai_mob'
require 'base_ai_casting'
require 'incl_regions'
require 'base_ai_intelligent'
require 'base_ai_conversation'
require 'incl_cultist_faction'
--require 'base_ai_sleeping'

AI.CombatSpeech = {
    --"Woe be upon you, feeble mortal.",
    "Your skills are the sum of years at best. Mine is the sum of aeons.",
    "Kho awaits you in the life beyond. Bend a knee, and behold the void!",
    "Ruin shall rain down upon you as shards of glass.",
    "Behold, as the risen agents of Kho prepare to dine upon your flesh!",

}

AI.IdleResponseNeutral={
    "Thou indeed.",
    "Hmph...",
    "Indeed.",
    "Hence is so.",
    "Right.",
    "It is so.",
}

AI.IdleResponsePositive={
    "Doth true.",
    "Art so.",
    "Yes.",
    "Truely.",
    "It is so.",
}

AI.IdleResponseNegative={
    "No.",
    "Naught so.",
    "I disagree.",
}

AI.IdleResponseAngry={

}

AI.IdleSpeech=
{
    "Blessed Kho, we await you.",
    "May devils take us from the agony of this world.",
    "Null and void await us all.",

}

AI.IdleSpeechQuestion = {
   
}

AI.IdleSpeechConcern={

}
--AI.IdleSpeechResponse=
--{}

AI.DemandSpeech = {

}

AI.StatementSpeech =  {

}

AI.BoastSpeech = {
    "" .. math.random(2,15) .. " have risen to serve Kho, by my hand.",

}

AI.ThreatSpeech = {
    "Your service in my master's legion is demanded and imminent.",
}

AI.JokeSpeech = {

}

AI.InsultSpeech = {

}

AI.GreetingSpeech =
{

}

AI.FarewellSpeech =
{

}

AI.CombatSpeechAnimal = {


}

AI.CombatSpeechAngry = {
    "Wtiness the quintessence of Kho's majesty!",
    "For the master, and myself, we rend your your spirit from your flesh!",
    "You'll be begging for mercy soon enough!",

}

AI.TauntSpeech = {
    "Accursed mortals, cower before us. Know well that we have sealed your fate.",

}

AI.FleeSpeech = {
    "Kho forsakes us.",
    "Impossible!",

}

AI.Settings.Debug = false
-- set charge speed and attack range in combat ai
AI.Settings.ChargeSpeed = 3.0

AI.Settings.AggroRange = 10.0
AI.Settings.ChaseRange = 15.0
AI.Settings.LeashDistance = 20
AI.Settings.CanSpeak = true
AI.Settings.ScaleToAge = false
AI.Settings.CanWander = false
AI.Settings.CanUseCombatAbilities = true
AI.Settings.CanCast = true
AI.Settings.ChanceToNotAttackOnAlert = 2

if (this:GetObjVar("controller") ~= nil) then
    AI.Settings.CanWander = true
end

function AssignCultistName()
    if( initializer.CultistNamed ~= nil ) then    
        local name = initializer.CultistNamed[math.random(#initializer.CultistNamed)]
        this:SetName(name.." the "..this:GetName())
    end
end

--Function that determine's what team I'm on. Override this for custom behaviour.
function IsFriend(target)
    --Override if this is my "target"
    if (AI.MainTarget ~=  nil and AI.MainTarget == target) then
        return false
    end

    if (target == nil) then
        DebugMessage("[ai_cultist|IsFriend] ERROR: target is nil")
        return true
    end

    if (target:HasModule("ai_slave") and not target:HasObjVar("Escaping")) then
        return true
    elseif (target:HasObjVar("Escaping")) then
        return false 
    end

    this:DebugMessage(tostring(target))
    if (target == nil) then
        return true
    end

    local myTeam = this:GetObjVar("MobileTeamType")
    if (myTeam == nil) then --If I have no team, then attack everyone!
        this:DebugMessage("NO TEAM")
        return false
    end


    local otherTeam = target:GetObjVar("MobileTeamType")

    if (this:HasObjVar("NaturalEnemy") ~= nil)  then
        if (this:GetObjVar("NaturalEnemy") == otherTeam) then
            return false
        end
    end

    if (target:GetMobileType() == "Animal" ) then --Animals don't usually attack animals
        if (this:DistanceFrom(target) < AI.Settings.AggroRange or math.random(AI.GetSetting("AggroChanceAnimals")) == 1) then            
            --AI.AddThreat(damager,-1)--Don't aggro them
            return (myTeam == otherTeam) 
        else
            return true
        end
    end
    if (otherTeam == nil) then
        return false
    end

    return (myTeam == otherTeam) --Return true if they have the same team, false if not.
end

AI.StateMachine.AllStates.Dead = {
        OnEnterState = function()   
           -- --DebugMessage("Dead start")   
            local campController = this:GetObjVar("controller")
            if( campController ~= nil ) then
                campController:SendMessage("cultist_death",this)
            end    
        end,

        OnExitState = function()

        end,
    }

AI.StateMachine.AllStates.Alert = {       
        OnEnterState = function() 
            this:PlayAnimation("alarmed")
            
            alertTarget = FindAITarget()
            if( alertTarget == nil ) then
               this:DebugMessage("Changing to idle from alert")
                AI.StateMachine.ChangeState("Idle")
            else
                this:FaceObject(alertTarget)
            end
            ----AI.StateMachine.--DebugMessage("ENTER ALERT")
        end,

        GetPulseFrequencyMS = function() return 1700 end,

        AiPulse = function()    
            --AI.StateMachine.--DebugMessage("Alert pulse")
            --this:NpcSpeech("[f70a79]*Alert!*[-]")
            alertTarget = FindAITarget()
            if( alertTarget == nil ) then
               this:DebugMessage("Changing to idle from alert")
                AI.StateMachine.ChangeState("Idle")
            else
                this:FaceObject(alertTarget)
                --We found a new mobile, handle it

                --if I should attack then
                local shouldAttack = true --should I attack
                local shouldAttackAnyway = true
                local chanceAttackAnyway = 10 --should I attack anyway
                local targetFaction = GetCultistFavorability(alertTarget) 

                --if I'm unencountered attack
                if (targetFaction == nil) then
                    this:DebugMessage("targetFaction is nil")
                    targetFaction = 0
                end

                --if my faction chance is less than ten then increase chance of randomized attack
                if (targetFaction <= 10) then
                    this:DebugMessage("randomizng")
                    chanceAttackAnyway = 100*targetFaction
                else 
                    chanceAttackAnyway = 1000
                end

                if (targetFaction == 0) then
                    this:DebugMessage("newly encountered")
                    chanceAttackAnyway = 100
                end

                --don't attack in ruins
                local regions = GetRegionsAtLoc(this:GetLoc())
                for i,j in pairs(regions) do
                    if j == "CultistRuins" or j == "LowerRuins" or j == "UpperRuins" then
                        this:DebugMessage("In ruins")
                        shouldAttack = false
                    end
                end
                for i,j in pairs(regions) do
                    if (j == "TopRuins" and targetFaction <= 10) then
                        this:DebugMessage("In top ruins")
                        shouldAttack = true
                    end
                end

                --if I'm an enemy of the cult attack
                if (targetFaction < 0) then
                    this:DebugMessage("Enemy of teh cult")
                    shouldAttack = true
                end
                --if I'm a member of the cult don't attack
                if (targetFaction > 10) then
                    this:DebugMessage("Member of teh cult")
                    shouldAttack = false
                    shouldAttackAnyway = false
                end

                for i,j in pairs(regions) do
                    if (j == "RuinsThroneRoom" and targetFaction <= 50) then
                        this:DebugMessage("In throne room")
                        shouldAttack = true
                    end
                end

                this:DebugMessage("CultistFavorability is " .. tostring(targetFaction))
                this:DebugMessage("shouldAttackAnyway is " .. tostring(shouldAttackAnyway))
                this:DebugMessage("shouldAttack is "..tostring(shouldAttack))
                this:DebugMessage("chanceAttackAnyway is "..tostring(chanceAttackAnyway))

                --I treat it as if it's something I should attack
                if (shouldAttack) then
                    if (math.random(1,AI.GetSetting("ChanceToNotAttackOnAlert")) == 1  or alertTarget:DistanceFrom(this) < AI.GetSetting("AggroRange")) then
                        if (not IsFriend(alertTarget)) then
                            AttackEnemy(alertTarget)
                        else --not a threat, go to idle
                            AI.StateMachine.ChangeState("Idle")
                        end
                    end
                else --I'm inside the ruins or I have a bit of cultist faction
                    if (shouldAttackAnyway) then
                        if (math.random(1,chanceAttackAnyway) == 1 ) then
                            if (not IsFriend(alertTarget)) then --I'm going to bop you to show you a thing or two
                                AttackEnemy(alertTarget)
                            else --not a threat, go to idle
                                AI.StateMachine.ChangeState("Idle")
                            end
                        else
                            if (math.random(1,chanceAttackAnyway/3) == 1 ) then --three times more likely to insult you rather than attack
                                InsultTarget(alertTarget)
                            end
                        end
                    else --greeting a member of the cult
                        if math.random(1,AI.GetSetting("ChanceToNotAttackOnAlert")) == 1 then
                            this:NpcSpeech("Hau-Kohmen, bretheren.")
                            AI.IdleTarget = alertTarget
                            AI.StateMachine.ChangeState("Converse")
                        else
                            AI.StateMachine.ChangeState("Idle")
                        end
                    end
                end
            end
        end,
    }

--Have them leash only if they have a home location
if (initializer ~= nil ) then
    if( this:HasObjVar("homeLoc")) then
        AI.Settings.Leash = true
        --DebugMessage("Has HomeLoc")
        -- set home facing
        local campController = this:GetObjVar("controller")
        if( campController ~= nil ) then
            --DebugMessage("Has controller")
            local facing = this:GetLoc():YAngleTo(campController:GetLoc())
            this:SetObjVar("homeFacing", facing)
        end
    end
    if( this:HasObjVar("homeRegion")) then
        AI.SetSetting("CanWander",true)
        --DebugMessage("Wanders")
    else
        AI.Settings.Leash = true  
        AI.SetSetting("CanWander",false)     
        --DebugMessage("Doesn't wander") 
    end
end

function IsInRuins()
    local inRuins = false
    local regions = GetRegionsAtLoc(this:GetLoc())
    for i,j in pairs(regions) do
        if j == "CultistRuins" then
            inRuins = true
        end
    end
    return inRuins
end

--reduce faction for damaging cultists
--When I get hit.
RegisterEventHandler(EventType.Message, "DamageInflicted", 
function (args)    

    --if I'm outside the ruins don't change faction
    if (not IsInRuins()) then
        return
    end

    local attacker = args[1]
    if (attacker ~= nil and attacker:IsValid()) then
        local targetFaction = GetCultistFavorability(attacker) 

        if (targetFaction == nil) then targetFaction = 0 end
 

        --bottoms out at -30
        if (targetFaction < -30) then
            targetFaction = -30
        end
        this:DebugMessage("CultistFavorability is "..targetFaction)
        ChangeFactionByAmount(attacker,-4)
    end
end)
--reduce faction for killing cultists
RegisterEventHandler(EventType.Message,"HasDiedMessage",
    function (killer)

    if (killer ~= nil and killer:IsValid()) then

        --if I'm outside the ruins don't change faction
        if (not IsInRuins()) then
            return
        end

        local targetFaction = GetCultistFavorability(killer) or 0
        --bottoms out at -30
        if (targetFaction < -30) then
            targetFaction = -30
        end
        if (targetFaction == nil) then targetFaction = 0 end

        targetFaction = targetFaction - 10  
        this:DebugMessage("CultistFavorability is "..targetFaction)
        ChangeFactionByAmount(killer,-10)
    end
end)
-- Every top level script needs to initialize the ai state machine
AI.Init()